
/*************************************************************************
* Title:    C include file for eDIP128
* Author:   Achim Seeger h.j.seeger@web.de
* File:     eDIP128.h
* Software: AVR-GCC 3.4.3 / avr-libc 1.2.3
* Target:   any AVR device
**************************************************************************/

///////////////////////////////////////////////////////////////////

// Bargraph Nr,x1,y1,x2,y2,Anfang,Ende,Strichbreite,Muster Fllung / immer zusammen mit unten - B+L
void Graphik_Bargraph_L(int8_t n, int8_t x1, int8_t y1, int8_t x2, int8_t y2, int8_t aw, int8_t ew, int8_t typ, int8_t mst);

// Bargraph Nr,x1,y1,x2,y2,Anfang,Ende,Strichbreite,Muster Fllung / immer zusammen mit unten - B+R
void Graphik_Bargraph_R(int8_t n, int8_t x1, int8_t y1, int8_t x2, int8_t y2, int8_t aw, int8_t ew, int8_t typ, int8_t mst);

// Bargraph Nr,x1,y1,x2,y2,Anfang,Ende,Strichbreite,Muster Fllung / immer zusammen mit unten - B+O
void Graphik_Bargraph_O(int8_t n, int8_t x1, int8_t y1, int8_t x2, int8_t y2, int8_t aw, int8_t ew, int8_t typ, int8_t mst);

// Bargraph Nr,x1,y1,x2,y2,Anfang,Ende,Strichbreite,Muster Fllung / immer zusammen mit unten - B+U
void Graphik_Bargraph_U(int8_t n, int8_t x1, int8_t y1, int8_t x2, int8_t y2, int8_t aw, int8_t ew, int8_t typ, int8_t mst);

// Bargraph Nummer und Wert / immer zusammen mit oben - B+A
void Graphik_Bargraph_aktuell(int8_t a1, int8_t a2);

//////////////////////////////////////////////////////////////////

// min x1=0, y1=0 max x2=127, y2=63 - G+R
void Graphik_Rechteck(int8_t a1, int8_t b1, int8_t x2, int8_t y2);

// Cursor aus=0, ein=1 - T+C
void Graphik_Cursor(int8_t a);

// Cursor Position max x=16 y=8 Grsse Cursor beachten - T+P
void Graphik_Cursor_Position(int8_t a, int8_t b);

// Gerade von x1,y1 zu x2, y2 - G+D
void Graphik_Gerade(int8_t x1, int8_t y1, int8_t x2, int8_t y2);

// Gerade weiter zu x, y - G+W		
void Graphik_Gerade_weiter(int8_t x1, int8_t y1);	

// allgemein fr alle x, y - G+Z
void Graphik_Punkt_Groesse(int8_t x1, int8_t y1);

// Ausgabe eines Punktes an x, y - G+P
void Graphik_Punkt(int8_t x1, int8_t y1);

// Blinken Display aus=0, ein=1, 2=inv 3=Phase - G+B
void Graphik_Blinken(int8_t a);

// Beleuchtung 1=ein 0=aus - Y+L
void Graphik_Beleuchtung(int8_t a);

// Helligkeit von 0 bis 100% - Y+H
void Graphik_Helligkeit(int8_t a);	

// alles lschen - D+L
void Graphik_loeschen(void);		

// alles invertieren - D+I		
void Graphik_invertieren(void);		

// Bereich invertieren und blinken x1, y1, x2, y2 - R+I
void Graphik_Bereich_invertieren(int8_t a1, int8_t b1, int8_t x2, int8_t y2);

// Bereich fuellen nicht blinken x1, y1, x2, y2 - G+R
void Graphik_Bereich_fuellen(int8_t a1, int8_t b1, int8_t x2, int8_t y2);

// Bereich loeschen x1, y1, x2, y2 - R+L
void Graphik_Bereich_loeschen(int8_t a1, int8_t b1, int8_t x2, int8_t y2);

// Bereich mit Muster fllen x1, y1, x2, y2, Muster siehe Hersteller - R+M
void Graphik_Bereich_Muster(int8_t a1, int8_t b1, int8_t a2, int8_t b2, int8_t m);

// Box mit Rahmen und mit Muster fllen - R+O
void Graphik_Box_zeichnen(int8_t a1, int8_t b1, int8_t a2, int8_t b2, int8_t m);

// Rahmen zeichnen mit Muster - R+R
void Graphik_Rahmen_zeichnen(int8_t a1, int8_t b1, int8_t a2, int8_t b2, int8_t m);

// Rahmenbox zeichnen - R+T		
void Graphik_Rahmenbox_zeichnen(int8_t a1, int8_t b1, int8_t a2, int8_t b2, int8_t m);

// Info Abfragen vom Display Typ usw. - T+I
void Graphik_Info(void);

// Abfrage Version vom Display - T+V
void Graphik_Version(void);

// Auswahl Schriftart (Font) siehe Datenblatt 1-7 - Z+F
void Graphik_Auswahl_Font(int8_t f);

// Ausgabe Schrift im Winkel von 90 Grad	0 - 0 Grad, 1 - 90 Grad - Z+W
void Graphik_Font_Winkel(int8_t w);

// Zoomt das gewhlte Font in x und y Grsse 1 bis 4 mal - Z+Z
void Graphik_Font_Zoom(int8_t z1, int8_t z2);	

// Ausgabe Text am gewhlten Ort links - Z+L
void Graphik_Text_ausgabe_L(int8_t x1, int8_t y1, char * Text);

// Ausgabe Text am gewhlten Ort techts - Z+R
void Graphik_Text_ausgabe_R(int8_t x1, int8_t y1, char * Text);

// Ausgabe Text am gewhlten Ort zentriert - Z+C
void Graphik_Text_ausgabe_Z(int8_t x1, int8_t y1, char * Text);

// Ausgabe Menue Inhalt und Rahmen - N+D
void Graphik_Menue_zeichnen(int8_t x1, int8_t y1, int8_t a1, char * Text);

// Menue Balken nach unten - weiter - N+N
void Graphik_Menue_weiter(void);	

//Menue Balken nach oben - zurck - N+P
void Graphik_Menue_zurueck(void);	

// Auswahl Schrift Menue - N+F
void Graphik_Menue_Font(int8_t f);
